package net.lensfrex.dscape.dao.entity;

import lombok.Data;
import java.io.Serializable;
import java.time.LocalDateTime;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;

/**
 * @description patient_data
 * @author lensfrex
 * @date 2022-08-17
 */
@Data
public class PatientData implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 数据id
     */
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 病人id
     */
    private Integer pid;

    /**
     * ctdna长度
     */
    private Integer ctdnaLength;

    /**
     * 甲基化位点数
     */
    private Integer cpg;

    /**
     * 是否为hcc，0: 否， 1: 是
     */
    private int isHcc;

    /**
     * 通过推断得出的hcc状态
     */
    private int isInferHcc;

    /**
     * create_time
     */
    private LocalDateTime createTime;

    /**
     * edit_time
     */
    private LocalDateTime editTime;

    /**
     * is_deleted
     */
    private int isDeleted;

    public PatientData() {}
}