/*
 * Class created by lensfrex.
 */

package net.lensfrex.dscape.dao.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.IService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import net.lensfrex.dscape.dao.entity.UserRole;
import net.lensfrex.dscape.dao.mapper.UserRoleMapper;
import net.lensfrex.dscape.dao.service.UserRoleService;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class UserRoleServiceImpl extends ServiceImpl<UserRoleMapper, UserRole> implements UserRoleService {

    @Override
    public List<String> getRoles(String uid) {
        QueryWrapper<UserRole> wrapper = new QueryWrapper<>();
        wrapper.lambda()
                .select(UserRole::getRole)
                .eq(UserRole::getUid, uid)
                .eq(UserRole::getIsDeleted, 0);

        List<UserRole> userRoleList = this.list(wrapper);
        List<String> roles = new ArrayList<>();

        userRoleList.forEach(userRole -> roles.add(userRole.getRole().toString()));

        return roles;
    }
}
