/*
 * Class created by lensfrex.
 */

package net.lensfrex.dscape.dto.response.general;

//@JsonInclude(JsonInclude.Include.NON_NULL)
public class Response<T> {
    private final int code;
    private final String message;
    private final T data;

    public Response(int code, String message, T data) {
        this.code = code;
        this.message = message;
        this.data = data;
    }

    public int getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }

    public T getData() {
        return data;
    }

    public static<T> Response<T> success(T data) {
        return new Response<>(ResponseCode.SUCCESS.getCode(), "success", data);
    }

    public static<T> Response<T> success() {
        return success(null);
    }

    public static<T> Response<T> error(ResponseCode code, String message) {
        return new Response<>(code.getCode(), message, null);
    }

    public static<T> Response<T> error(ResponseCode code) {
        return error(code, code.getMessage());
    }
}