/*
 * Class created by lensfrex.
 */

package net.lensfrex.dscape.dto.response.general;

public enum ResponseCode {
    SUCCESS(20000, "成功"),
    INVALID_REQUEST(30000, "非法请求"),
    PARAM_WRONG(30001, "参数错误"),
    PERMISSION_DENIED(40000, "权限不足"),
    TOKEN_EXPIRED(40001, "token过期"),
    TOKEN_INVALID(40002, "token无效"),
    SERVER_INTERNAL_ERROR(50000, "服务器内部错误"),
    API_NOT_IMPLEMENT(0, "接口未实现"),

    USERNAME_OR_PASSWORD_WRONG(40301, "用户名或密码不正确"),
    USER_WAS_BANNED(40302, "用户已被封禁"),
    USER_WAS_NOT_IDENTIFIED(40301, "上级管理员未认证该用户"),

    ;

    private final int code;

    private final String message;

    ResponseCode(int code, String message) {
        this.code = code;
        this.message = message;
    }

    public int getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }
}
